<?php

require_once DOL_DOCUMENT_ROOT . '/compta/facture/class/facture.class.php';
require_once DOL_DOCUMENT_ROOT . '/compta/facture/class/facture-rec.class.php';
require_once DOL_DOCUMENT_ROOT . '/compta/paiement/class/paiement.class.php';
$res = 0;
if (! $res && file_exists(DOL_DOCUMENT_ROOT."/contratPlus/fonction.php")) {
	$res = @include(DOL_DOCUMENT_ROOT."/contratPlus/fonction.php");
}
if (! $res && file_exists(DOL_DOCUMENT_ROOT."/custom/contratPlus/fonction.php")) {
	$res = @include(DOL_DOCUMENT_ROOT."/custom/contratPlus/fonction.php");
}
if (! $res) die("Include of /contratPlus/fonction.php fails");
$res = 0;
if (! $res && file_exists(DOL_DOCUMENT_ROOT."/contratPlus/class/actions_update.class.php")) {
	$res = @include(DOL_DOCUMENT_ROOT."/contratPlus/class/actions_update.class.php");
}
if (! $res && file_exists(DOL_DOCUMENT_ROOT."/custom/contratPlus/class/actions_update.class.php")) {
	$res = @include(DOL_DOCUMENT_ROOT."/custom/contratPlus/class/actions_update.class.php");
}
if (! $res) die("Include of /contratPlus/class/actions_update.class.php fails");

class ActionsContratPlus
{
	/**
	 * Overloading the doActions function : replacing the parent's function with the one below
	 *
	 * @param   array()         $parameters     Hook metadatas (context, etc...)
	 * @param   CommonObject    &$object        The object to process (an invoice if you are in invoice module, a propale in propale's module, etc...)
	 * @param   string          &$action        Current action (if set). Generally create or edit or null
	 * @param   HookManager     $hookmanager    Hook manager propagated to allow calling another hook
	 * @return  int                             < 0 on error, 0 on success, 1 to replace standard code
	 */
	function doActions($parameters, &$object, &$action, $hookmanager)
	{
		global $user, $db, $langs, $form, $conf;

		/* trouver l'option choisie*/
		$sql = "SELECT llx_contratplus.active FROM llx_contratplus WHERE llx_contratplus.name = 'OPTION'";
		$resql = $db->query($sql);
		$res = $resql->fetch_assoc();
		$option = $res['active'];

		if ($parameters['currentcontext'] == 'contractcard')
		{
			/* check de début bypass */
			if ($action == "renewal")
			{
				$bypass = getInfoOnBDD("BYPASS");
				if ($bypass['active'] == 1)
					header ("Location: ".$_SERVER['PHP_SELF']."?id=".$object->id."&action=confirm_renewal");
			}

			/* déclaration et initialisation des variables */
			$nb_lines = 0;
			while (isset($object->lines[$nb_lines]))
				$nb_lines++;
			$i = 0;

			if ($action == "confirm_renewal")
			{
				while ($i < $nb_lines)
				{
					if ($object->lines[$i]->statut == 4)
					{
						$date1 = strtotime(date("Y-m-d"));
						$date2 = strtotime(date("Y-m-d", $object->lines[$i]->date_fin_validite));
						if ($date1 > $date2)
						{
							//cloture la ligne
							$res = $object->close_line($user, $object->lines[$i]->id, $date1, $comment='');

							//trouve la durée du contrat
						    $sql = "SELECT llx_product.duration FROM llx_product WHERE llx_product.rowid = ".$object->lines[$i]->fk_product;
						    dol_syslog($sql, LOG_DEBUG);
							$resql = $db->query($sql);
							$duration = $resql->fetch_assoc();

							//on ajoute la durée du contrat à la date d'aujourd'hui
						    if ($duration['duration'])
						    {
						    	$j = 0;
						    	$nb = "";
						    	while ($duration['duration'][$j])
						    	{
						    		if ($duration['duration'][$j] == 'h')
						    			$ext = "hours";
						    		else if ($duration['duration'][$j] == 'j')
						    			$ext = "days";
						    		else if ($duration['duration'][$j] == 'm')
						    			$ext = "month";
						    		else if ($duration['duration'][$j] == 'y')
						    			$ext = "years";
						    		else
						    			$nb = $nb.$duration['duration'][$j];
						    		$j++;
						    	}
						    	$time = "+".$nb." ".$ext;
						    }
						    $date_end = date('Y-m-d',strtotime($time ,$date1));
								    
						    //active la ligne
						    $object->active_line($user, $object->lines[$i]->id, $date1, $date_end, $comment='');
						}
					}
					$i++;
				}
				//supprime dans base de donnée
				$sql = "DELETE FROM llx_contratplus WHERE llx_contratplus.value='".$object->id."'";
				dol_syslog($sql, LOG_DEBUG);
    			$db->query($sql);
				
				//redirige la page
				if ($option == 0)
				{
					if (update_renewall_all() == 0)
						header("Location: ".$_SERVER['PHP_SELF']."?id=".$object->id);		
				}
				else
				{
					$origin 			= $object->element;
	 				$originid 			= $object->id;
	 				$socid 				= $object->thirdparty->id;
	 				$cond_reglement_id 	= $object->thirdparty->cond_reglement_id != "" ? $object->thirdparty->cond_reglement_id : 1;
					$mode_reglement_id 	= $object->thirdparty->mode_reglement_id;
					$fk_account        	= $soc->fk_account;
					$remise_percent 	= $soc->remise_percent;
					$remise_absolue 	= 0;
					$note_private   	= $object->thirdparty->note_private;
					$ref_client     	= $object->ref_customer;
					$ref_int     		= $object->thirparty->ref_int;
					$modelpdf       	= $object->thirdparty->modelpdf != "" ? $object->thirdparty->modelpdf : "crabe";
					$fk_incoterms 		= $object->fk_incoterms;
					$location_incoterms = $object->fk_incoterms;
					$fk_account         = $object->fk_account;
					$new_date			= date("Y-m-d", $object->lines[0]->date_ouverture);
					$date 				= date(strtotime($new_date.' - 1 DAY'));
					$note_public		= $object->thirdparty->note_public;
					$note_public		.= "La facture fait partie du trimestre ".find_date(3, "actual", date("Y-m-d", $date));
					$action = "action=renewal_create&origin=".$origin."&originid=".$originid."&socid=".$socid."&cond_reglement_id=".$cond_reglement_id."&mode_reglement_id=".$mode_reglement_id."&fk_account=".$fk_account."&remise_percent=".$remise_percent."&remise_absolue=".$remise_absolue."&note_public=".$note_public."&note_private=".$note_private."&ref_client=".$ref_client."&ref_int=".$ref_int."&modelpdf=".$modelpdf."&fk_incoterms=".$fk_incoterms."&location_incoterms=".$location_incoterms."&fk_account=".$fk_account."&date=".$date;
					header("Location: ".DOL_URL_ROOT."/compta/facture.php?".$action);
				}
			}
		}
		else if ($parameters['currentcontext'] == 'globalcard')
		{
			/* début création brouillon */
			if ($action == "renewal_create")
			{
				$origin = GETPOST('origin');
	 			$object->origin_id = $originid = GETPOST('originid');
	 			$socid = GETPOST('socid');
				

				/* new */
				$object->socid				= $socid;
				$object->date           	= GETPOST('date');
				$object->note_public		= trim(GETPOST('note_public'));
				$object->note				= trim(GETPOST('note_private'));
				$object->ref_client			= GETPOST('ref_client');
				$object->ref_int			= GETPOST('ref_int');
				$object->modelpdf			= GETPOST('modelpdf');
				$object->cond_reglement_id	= GETPOST('cond_reglement_id');
				$object->mode_reglement_id	= GETPOST('mode_reglement_id');
		        $object->fk_account         = GETPOST('fk_account', 'int');
				$object->remise_absolue		= GETPOST('remise_absolue');
				$object->remise_percent		= GETPOST('remise_percent');
				$object->fk_incoterms 		= GETPOST('fk_incoterm', 'int');
				$object->location_incoterms = GETPOST('location_incoterms', 'alpha');

				/* clacul du nombre de jour pour le payement */
				if ($object->cond_reglement_id != "")
					$object->cond_reglement_id = 1;
				$sql = "SELECT llx_c_payment_term.nbjour FROM llx_c_payment_term WHERE llx_c_payment_term.rowid = ".$object->cond_reglement_id;
				dol_syslog($sql, LOG_DEBUG);
				$res = $db->query($sql);
				$nb = $res->fetch_assoc();

				$datelim = date(strtotime($object->date.'+ '.$nb['nbjour'].' DAY'));

				/* création de la facture */
				$id = $object->create($user, 0, $datelim);
				
				$facture_source = new Facture($db); // fetch origin object

				dol_include_once('/' . $origin . '/class/' . $origin . '.class.php');
	            $classname = ucfirst($origin);
	            $srcobject = new $classname($db);
				$result = $srcobject->fetch($object->origin_id);

				/* ajout de chaque ligne de service */
	         	if ($result > 0)
				{
					$lines = $srcobject->lines;
					if (empty($lines) && method_exists($srcobject, 'fetch_lines'))
					{
						$srcobject->fetch_lines();
						$lines = $srcobject->lines;
					}

					$fk_parent_line=0;
					$num=count($lines);
					for ($i=0;$i<$num;$i++)
					{
						// Don't add lines with qty 0 when coming from a shipment including all order lines
						if($srcobject->element == 'shipping' && $conf->global->SHIPMENT_GETS_ALL_ORDER_PRODUCTS && $lines[$i]->qty == 0) continue;

						$label=(! empty($lines[$i]->label)?$lines[$i]->label:'');
						$desc=(! empty($lines[$i]->desc)?$lines[$i]->desc:$lines[$i]->libelle);
						if ($object->situation_counter == 1) $lines[$i]->situation_percent =  0;

						if ($lines[$i]->subprice < 0)
						{
							// Negative line, we create a discount line
							$discount = new DiscountAbsolute($db);
							$discount->fk_soc = $object->socid;
							$discount->amount_ht = abs($lines[$i]->total_ht);
							$discount->amount_tva = abs($lines[$i]->total_tva);
							$discount->amount_ttc = abs($lines[$i]->total_ttc);
							$discount->tva_tx = $lines[$i]->tva_tx;
							$discount->fk_user = $user->id;
							$discount->description = $desc;
							$discountid = $discount->create($user);
							if ($discountid > 0) {
								$result = $object->insert_discount($discountid); // This include link_to_invoice
							} else {
								setEventMessages($discount->error, $discount->errors, 'errors');
								$error ++;
								break;
							}
						} else {
							// Positive line
							$product_type = ($lines[$i]->product_type ? $lines[$i]->product_type : 0);

							// Date start
							$date_start = false;
							if ($lines[$i]->date_debut_prevue)
								$date_start = $lines[$i]->date_debut_prevue;
							if ($lines[$i]->date_debut_reel)
								$date_start = $lines[$i]->date_debut_reel;
							if ($lines[$i]->date_start)
								$date_start = $lines[$i]->date_start;

							// Date end
							$date_end = false;
							if ($lines[$i]->date_fin_prevue)
								$date_end = $lines[$i]->date_fin_prevue;
							if ($lines[$i]->date_fin_reel)
								$date_end = $lines[$i]->date_fin_reel;
							if ($lines[$i]->date_end)
								$date_end = $lines[$i]->date_end;

							// Reset fk_parent_line for no child products and special product
							if (($lines[$i]->product_type != 9 && empty($lines[$i]->fk_parent_line)) || $lines[$i]->product_type == 9) {
								$fk_parent_line = 0;
							}

							// Extrafields
							if (empty($conf->global->MAIN_EXTRAFIELDS_DISABLED) && method_exists($lines[$i], 'fetch_optionals')) {
								$lines[$i]->fetch_optionals($lines[$i]->rowid);
								$array_options = $lines[$i]->array_options;
							}

							// View third's localtaxes for now
							$localtax1_tx = get_localtax($lines[$i]->tva_tx, 1, $object->client);
							$localtax2_tx = get_localtax($lines[$i]->tva_tx, 2, $object->client);

							$result = $object->addline($desc, $lines[$i]->subprice, $lines[$i]->qty, $lines[$i]->tva_tx, $localtax1_tx, $localtax2_tx, $lines[$i]->fk_product, $lines[$i]->remise_percent, $date_start, $date_end, 0, $lines[$i]->info_bits, $lines[$i]->fk_remise_except, 'HT', 0, $product_type, $lines[$i]->rang, $lines[$i]->special_code, $object->origin, $lines[$i]->rowid, $fk_parent_line, $lines[$i]->fk_fournprice, $lines[$i]->pa_ht, $label, $array_options, $lines[$i]->situation_percent, $lines[$i]->fk_prev_id, $lines[$i]->fk_unit);

							if ($result > 0) {
								$lineid = $result;
							} else {
								$lineid = 0;
								$error ++;
								break;
							}

							// Defined the new fk_parent_line
							if ($result > 0 && $lines[$i]->product_type == 9) {
								$fk_parent_line = $result;
							}
						}
					}
				}
				/* end ajout des lignes de service*/
				/* end création brouillon */

				if ($option == 1)
				{
					if (update_renewall_all() == 0)
						header("Location: ".DOL_URL_ROOT."/compta/facture/list.php");
				}
				else
					update_renewall($option, $object, $action);
			}

			add_option($option, $object, $action);
			update_renewall_all();
		}
	}


	/**
	 * Adds more actions buttons.
	 *
	 * @param   array()         $parameters     Hook metadatas (context, etc...)
	 * @param   CommonObject    &$object        The object to process (an invoice if you are in invoice module, a propale in propale's module, etc...
	 * @param   string          &$action        Current action (if set). Generally create or edit or null
	 * @param   HookManager     $hookmanager    Hook manager propagated to allow calling another hook
	 * @return  int                             < 0 on error, 0 on success, 1 to replace standard code
	 */
	function addMoreActionsButtons($parameters, &$object, &$action, $hookmanager)
	{
		global $user, $db, $lang, $form;

		if ($parameters['currentcontext'] == 'contractcard')
		{
			$nb_lines = 0;
			while (isset($object->lines[$nb_lines]))
				$nb_lines++;

			if ($action == 'renewal')
			{
				$i = 0;
				$text = "Nous allons renouveller le/les service(s) suivant(s): <br/>";
				$check = 0;
				while ($i < $nb_lines)
				{
					if ($object->lines[$i]->statut == 4)
					{

						$date1 = strtotime(date("Y-m-d"));
						$date2 = strtotime(date("Y-m-d", $object->lines[$i]->date_fin_validite));
						if ($date1 > $date2)
						{
							
	 						$sql = "SELECT llx_product.duration FROM llx_product WHERE llx_product.rowid = ".$object->lines[$i]->fk_product;
	 						dol_syslog($sql, LOG_DEBUG);
							$resql = $db->query($sql);
							$duration = $resql->fetch_assoc();

							//on ajoute la durée du contrat à la date d'aujourd'hui
						    if ($duration['duration'])
						    {
						    	$j = 0;
						    	$nb = "";
						    	while ($duration['duration'][$j])
						    	{
						    		if ($duration['duration'][$j] == 'h')
						    			$ext = "heure(s)";
						    		else if ($duration['duration'][$j] == 'j')
						    			$ext = "jour(s)";
						    		else if ($duration['duration'][$j] == 'm')
						    			$ext = "mois";
						    		else if ($duration['duration'][$j] == 'y')
						    			$ext = "an(s)";
						    		else
						    			$nb = $nb.$duration['duration'][$j];
						    		$j++;
						    	}
						    	$time = $nb." ".$ext;
						    }
							$new_text = "- Service numéro ".($i + 1)." -> ".$object->lines[$i]->ref.": Pour une durée de ".$time.";<br/> ";
							$text = $text.$new_text;
							$check++;
						}
						
					}
					$i++;

				}
				if ($check == 0)
					$text = "Il n'y a aucun service(s) à renouveller";
					print $form->formconfirm($_SERVER['PHP_SELF']."?id=".$object->id,"Valider le renouvellement",$text,"confirm_renewal",'',0,1);
			}

			if ($object->statut == 1 && $object->element == "contrat")
				print '<div class="inline-block divButAction"><a class="butAction" href="'.$_SERVER["PHP_SELF"].'?id='.$object->id.'&amp;action=renewal">Renouveler</a></div>';
		}
	}
}
	
?>