<!-- NE PAS OUBLIER DE DECLARER  "global $user, $db, $langs, $form, $conf;" -->
<?php

    function getInfoOnBDD($str)
    {
        global $user, $db, $langs, $form, $conf;

        if (isset($str) && $str != "")
        {
            $sql = "SELECT * FROM llx_contratplus WHERE llx_contratplus.name = '".$str."'";
            dol_syslog($sql, LOG_DEBUG);
            $res = $db->query($sql);
            if ($db->num_rows($res) > 0)
                return ($res->fetch_assoc());
            else
                return (-2);
        }
        else
            return (-1);
    }

    function getValueOnBDD($str)
    {
        $nom_emetteur = getInfoOnBDD("NOM_EMETTEUR");
        $mail_emetteur = getInfoOnBDD("MAIL_EMETTEUR");
        $destinataire = getInfoOnBDD("DESTINATAIRE");
        $objet = getInfoOnBDD("OBJET");
        $message = getInfoOnBDD("MESSAGE");
        $facture = getInfoOnBDD("FACTURE");
        if ($str == "nom_emetteur")
            return ($nom_emetteur['value']);
        else if ($str == "mail_emetteur")
            return ($mail_emetteur['value']);
        else if ($str == "destinataire")
            return ($destinataire['value']);
        else if ($str == "objet")
            return ($objet['value']);
        else if ($str == "message")
            return ($message['value']);
        else if ($str == "facture")
            return ($facture['value']);
    }

    function insertOnBDD($name, $value)
    {
        global $db;

        $sql = "UPDATE llx_contratplus SET value = '".$value."' WHERE name = '".$name."'";
        dol_syslog($sql, LOG_DEBUG);
        $db->query($sql);
    }

    function printDetailedName($str)
    {
        if ($str == "nom_emetteur")
            return ('Nom de l\'emetteur');
        else if ($str == "mail_emetteur")
            return ('Email de l\'emetteur');
        else if ($str == "destinataire")
            return ('Email du destinataire');
        else if ($str == "objet")
            return ('Objet du mail');
        else if ($str == "message")
            return ('Contenu du mail');
        else if ($str == "facture")
            return ('Envoyer la facture');
    }

    /* ########## */
    /* Description */
    /* La fonction find_date permet de récupérer des informations sur les mois, trimestres, semestres, années en fonction d'une date donné et celon différentes options*/
    /* ########## */
    /* Prototype: */
    /* int    find_date(int nb, string option, string date); */
    /* ########## */
    /* Nb: */
    /* - '1'  : Informations sur le mois */
    /* - '3'  : Informations sur le trimestre */
    /* - '6'  : Informations sur le semestre */
    /* - '12' : Information sur l'année */
    /* ########## */
    /* Option: */
    /* - "actual"   : trouver le [nb] en cours */
    /* - "firstD"   : trouver le premier jour du [nb] */
    /* - "lastD"    : trouver le dernier jour du [nb] */
    /* - "lastDpast": trouver le dernier jour du mois précédent le [nb] */
    /* ########## */
    /* Date: */
    /* La date doit être sous les format YYYY-MM-DD avec une date valide */
    /* ########## */
    /* Return value: */
    /* - '0'  : aucune erreur */
    /* - '-1' : le format de la date n'est pas bon ou ne contient pas de chiffre exemple: 03/0j/2010*/
    /* - '-2' : la date n'est pas valide exemple: 03/13/2010 */
    /* - '-3' : l'option 'nb' n'est pas valide */
    /* - '-4' : l'option 'option' n'est pas valide */
    /* ########## */
    /* Note: */
    /* La fonction ne fonctionne pas pour des années supèrieurs à 9999 et inférieurs à 1000 */
    /* ########## */
    /* Created by Fabien Fernandes Alves */
    /* ########## */

    /* return 1 si la date n'est pas au bon format */
    function error_format($str)
    {
        $i = 0;
        while ($i < 10)
        {
            if ($i == 4 OR $i == 7)
                $i++;
            if (! is_numeric($str[$i]))
                return (1);
            $i++;
        }
        return (0);
    }

    /* return 1 si la date n'est pas valide */
    function error_date($day, $month)
    {
        if ($day <= 0 OR $day > 31)
            return (1);
        if ($month <= 0 OR $month > 12)
            return (1);
        return (0);
    }

    /* return une partie de $str de $i à $j */
    /* exemple: $str = "souris" $i = 0, $j = 3 */
    /*          $res = "sou" */
    function find_part($str, $i, $j)
    {
        $res = "";
        while ($i < $j)
        {
            $res = $res.$str[$i];
            $i++;
        }
        return ($res);
    }

    /* return le premier jour */
    function find_first($trimester)
    {
        if ($trimester == 1)
            return ("-01-01");
        if ($trimester == 2)
            return ("-04-01");
        if ($trimester == 3)
            return ("-07-01");
        if ($trimester == 4)
            return ("-10-01");
    }

    /* return le dernier jour */
    function find_last($trimester)
    {
        if ($trimester == 1)
            return ("-03-31");
        if ($trimester == 2)
            return ("-06-30");
        if ($trimester == 3)
            return ("-09-30");
        if ($trimester == 4)
            return ("-12-31");

    }

    /* fonction principale: parse l'option et effectue une tache en fonction de l'option et du "choix des informations" (mois, trimestre, semestre, année) */
    function find_mensual($option, $month, $year, $date, $str)
    {
        $tmp2 = floor(($month - 1) / 3) + 1;
        if ($option == "actual") //option actual
        {
            if ($str == "trim")
                return ($tmp2);
            if ($str == "sem")
                return ($tmp2 <= 2 ? 1 : 2);
            if ($str == "month")
                return ($year.'-'.$month);
            if ($str == "year")
                return ($year);
        }
        if ($option == "firstD") //option firstD
        {
            if ($str == "trim")
                return ($year.(find_first($tmp2)));
            if ($str == "sem")
                return ($year.(find_first($tmp2 <= 2 ? 1 : 3)));
            if ($str == "year")
                return ($year."-01-01");
            return (date('Y-m-d', (strtotime('first day of this '.$str, $date))));
        }
        if ($option == "lastD") //option lastD
        {
            if ($str == "trim")
                return ($year.(find_last($tmp2)));
            if ($str == "sem")
                return ($year.(find_last($tmp2 <= 2 ? 2 : 4)));
            if ($str == "year")
                return ($year."-12-31");
            return (date('Y-m-d', (strtotime('last day of this '.$str, $date))));
        }
        if ($option == "lastDpast") //option lastDpast
        {
            if ($str == "trim")
            {
                if ($tmp2 - 1 <= 0)
                    (int)$year -= 1;
                return ($year.(find_last($tmp2 - 1 <= 0 ? 4 : $tmp2 - 1)));
            }
            if ($str == "sem")
            {
                if ($tmp2 <= 2)
                    (int)$year -= 1;
                return ($year.(find_last($tmp2 <= 2 ? 4 : 2)));
            }
            $tmp = $year - 1;
            if ($str == "year")
                return ($tmp."-12-31");
            return (date('Y-m-d', (strtotime('last day of previous '.$str, $date))));
        }
        print "Wrong option.<br/> Option: 'firstD', 'lastD', 'lastDpast', 'actual'";
        return (-4);
    }

    /* parsing des options et gestion des erreurs*/
    function find_date($nb, $option, $date)
    {
        $date = substr($date, 0, 10);
        if (strlen($date) != 10 OR error_format($date) == 1 OR $date[4] != '-' OR $date[7] != '-')
        {
            print "Wrong date format. Date need to be like YYYY-MM-DD.<br/>";
            return (-1);
        }
        else
        {
            $year = find_part($date, 0, 4); //récupération de l'année de la date
            $month = find_part($date, 5, 7); //récupération du mois de a date
            $day = find_part($date, 8, 10); //récupération du jour de la date
            $date = strtotime($date); //transforme la date en timestamp Unix
            if (error_date($day, $month) == 1)
            {
                print "Wrong date. Your date need to be valid.<br/>";
                return (-2);
            }
            if ($nb == 1)
                return (find_mensual($option, $month, $year, $date, "month"));
            if ($nb == 3)
                return (find_mensual($option, $month, $year, $date, "trim"));
            if ($nb == 6)
                return (find_mensual($option, $month, $year, $date, "sem"));
            if ($nb == 12)
                return (find_mensual($option, $month, $year, $date, "year"));
            print "Wrong number option.<br/> Option: 1, 3, 6 or 12.<br/>";
            return (-3);
        }
    }

    /* end fonction find_date */
?>